/*
 * src/AtomSpace/NullTruthValue.h
 *
 * Copyright (C) 2002-2007 Novamente LLC
 * All Rights Reserved
 *
 * Written by Welter Silva <welter@vettalabs.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License v3 as
 * published by the Free Software Foundation and including the exceptions
 * at http://opencog.org/wiki/Licenses
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, write to:
 * Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef _NULL_TRUTH_VALUE_TV_H_
#define _NULL_TRUTH_VALUE_TV_H_

#include "TruthValue.h"

namespace opencog
{

class NullTruthValue : public TruthValue
{

    friend class TruthValue;

public:
    bool isNullTv() const;
    float getMean() const throw (RuntimeException);
    float getCount() const throw (RuntimeException);
    float getConfidence() const  throw (RuntimeException);
    float toFloat() const throw (RuntimeException);
    std::string toString() const;
    TruthValueType getType() const throw (RuntimeException);

    virtual bool operator==(const TruthValue& rhs) const;

protected:
    // TODO: Make this constructor protected. For some reason compiler is
    // complaining if it's declared protected.
    NullTruthValue();
    TruthValue* merge(TruthValue*) throw (RuntimeException);
    TruthValue* clone() const throw (RuntimeException);
    NullTruthValue& operator=(const TruthValue& rhs) throw (RuntimeException);
};

} // namespace

#endif
